<script lang="ts">
import Vue from 'vue';
import CodeSuggestionsSalesFormWrapper from './code-suggestions-sales-form-wrapper.vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'CodeSuggestionsSalesContent',
  components: { CodeSuggestionsSalesFormWrapper },
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    form: {
      type: Object,
      required: true,
      default: null,
    },
  },
  methods: {
    onFormSubmit() {
      this.$emit('submit');
    },
  },
});
</script>

<template>
  <section class="code-suggestions-sales-content">
    <SlpContainer
      variant="light-purple-100"
      class="code-suggestions-sales-content__container"
    >
      <SlpRow class="code-suggestions-sales-content__row">
        <SlpColumn :cols="6">
          <div
            class="code-suggestions-sales-content__wrapper"
            data-aos="fade-down"
            data-aos-duration="800"
          >
            <div class="code-suggestions-sales-content__video">
              <iframe
                frameborder="0"
                :src="createVideoSource(data.video.url)"
                style="
                  position: absolute;
                  top: 0;
                  left: 0;
                  width: 100%;
                  height: 100%;
                "
                :title="data.video.title"
                allow="autoplay; fullscreen; picture-in-picture"
                allowfullscreen
              ></iframe>
            </div>
            <div>
              <ul
                v-if="data.list.length"
                class="slp-mb-32 code-suggestions-sales-content__list"
              >
                <li
                  v-for="item in data.list"
                  :key="item.text"
                  class="code-suggestions-sales-content__list-item slp-mt-24"
                >
                  <SlpIcon
                    v-if="item.iconName"
                    :icon="item.iconName"
                    size="lg"
                    class="slp-mr-16 code-suggestions-sales-content__icon"
                  />
                  <SlpTypography v-if="item.text" tag="span" variant="body1">
                    {{ item.text }}
                  </SlpTypography>
                </li>
              </ul>
            </div>
            <div v-if="data.description" class="slp-mb-32">
              <SlpTypography
                variant="body1"
                tag="span"
                class="code-suggestions-sales-content__note"
                >{{ data.description }}
              </SlpTypography>
            </div>
            <SlpButton
              v-if="data.button"
              :href="data.button.externalUrl"
              variant="primary"
              :data-ga-name="data.button.dataGaName"
              :data-ga-location="data.button.dataGaLocation"
              class="slp-mt-32 slp-mb-64 code-suggestions-sales-content__button"
            >
              <SlpIcon
                :icon="data.button.iconName"
                :variant="data.button.iconVariant"
                size="md"
                class="slp-mr-8"
              />
              {{ data.button.text }}
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn :cols="6">
          <CodeSuggestionsSalesFormWrapper
            data-aos="fade-up"
            data-aos-duration="750"
            :data="form"
            @submit="onFormSubmit"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.code-suggestions-sales-content {
  &__video {
    height: 0;
    width: 100%;
    padding-bottom: 58%;
    position: relative;
    @media (min-width: $breakpoint-md) {
      margin-top: 174px;
    }
  }
  &__list-item {
    display: flex;
  }
  &__icon {
    height: $spacing-32;
    width: $spacing-32;
    display: flex;
    align-items: flex-start;
  }
  &__wrapper {
    // padding-right: $spacing-96;
    @media (min-width: $breakpoint-md) {
      padding-right: $spacing-96;
    }
  }
  &__container {
    padding-bottom: $spacing-96;
    @media (min-width: $breakpoint-md) {
      padding-bottom: $spacing-96;
    }
  }
  &__row {
    margin-top: -140px;
    @media (min-width: $breakpoint-md) {
      margin-top: -256px;
    }
  }
  &__button {
    background-color: transparent;
    color: $color-primary-200;
    width: 100%;
    text-align: center;
    justify-content: center;
    @media (min-width: $breakpoint-md) {
      width: auto;
    }
    &:hover,
    &:focus {
      color: $color-primary-300;
      background: $color-primary-200;
    }
  }
  :deep {
    .slp-col-md-6 {
      width: 100%;
    }
  }
  &__list {
    padding: $spacing-24;
    @media (min-width: $breakpoint-md) {
      padding: 0;
    }
  }
  &__note {
    color: $color-surface-500;
    margin-top: auto;
    font-style: italic;
  }
}
</style>
